stages:
  - verify
  - test
  - build

commitlint:
  stage: verify
  image: docker.io/library/node:17-alpine
  before_script:
    - apk add --no-cache git
    - npm install --save-dev @commitlint/config-conventional @commitlint/cli
  script:
    - npx commitlint --from ${CI_MERGE_REQUEST_TARGET_BRANCH_SHA} --to HEAD --verbose
  only:
    - merge_requests

golangci:
  stage: test
  image: docker.io/golangci/golangci-lint:latest
  before_script:
    - go mod download
  script:
    - golangci-lint run -v
  only:
    - merge_requests

unit-test-1.19:
  stage: test
  image: docker.io/library/golang:1.19
  script:
    - make test
  only:
    - merge_requests

e2e-test-1.19:
  stage: test
  image: docker.io/library/golang:1.19
  script:
    - make e2e
  only:
    - merge_requests

unit-test-codecov:
  stage: test
  image: docker.io/library/golang:1.19
  script:
    - make test
    - curl -Os https://uploader.codecov.io/latest/linux/codecov
    - chmod +x codecov
    - ./codecov
  only:
    - main

oci-build:
  stage: build
  image: quay.io/buildah/stable:latest
  script:
    - ./scripts/oci-build.sh
  variables:
    REGISTRY: "registry.gitlab.com"
    REPOSITORY: "sat-polsl/gcs"
    IMAGE_NAME: "gcs-api-server"
    IMAGE_TAG: ${CI_COMMIT_TAG}
  only:
    - tags
  except:
    - branches
